#ifndef ES_H
#define ES_H 

#include<cmath>
#include<algo.h>
#include <vector.h>
#include<iostream.h>
#include "./fitness.h"
#include "./individual.h"

using namespace std;

// ****************************************************************
//  (1+1)-ES with 1/5th rule 
// ****************************************************************

Individual OnePlusOneES( 
  const Individual& parent_init,      // initial parent 
  double sigma_init,                  // initial mutation strength
  size_t max_number_of_generations,   // stop condition: max. no. of generat.
  double stop_cond_sigma,             // stop condition: minimal sigma_0
  double success_prob = 0.2 )         // desired success probability
//
{ size_t o_dim = parent_init.object_parameter.size();
  size_t success_count;
//
  Individual parent = parent_init;
  Individual offspring;
//
  double sigma = sigma_init;
  size_t l_evo = o_dim;
  size_t gen_count = 0;
  do 
  { success_count = 0;
    for(size_t l=0; l < l_evo; l++)
    { gen_count++;
      parent.evaluate();
      offspring = parent; 
      offspring.mutate(sigma);
      offspring.evaluate();
      if( offspring < parent ) 
      { parent = offspring; 
        success_count++;
        cout << gen_count << "  " << parent.fitness << "  " << sigma << endl;
      }
      if( gen_count >= max_number_of_generations || 
          sigma < stop_cond_sigma ) return parent;
    }
    if( ((double) success_count)/((double) l_evo) < success_prob ) 
      sigma = sigma*0.8;
    else sigma = sigma/0.8;
  } while( true );
}
// ****************************************************************
#endif
