#ifndef INDIVIDUAL_H
#define INDIVIDUAL_H 

#include<cmath>
#include<vector.h>
#include<iostream.h>
#include "./random_generators.h"

using namespace std;

class Individual 
{ 
  public:
    double fitness;
    vector<double> object_parameter;
    void evaluate();
    void mutate(double);
};

// ****************************************************************

void Individual::evaluate()
{ double objective_function( const vector<double> &);
  fitness = objective_function(object_parameter);
}

// ****************************************************************

void Individual::mutate(double sigma)
{ size_t o_dim = object_parameter.size();
  for(size_t i=0; i < o_dim; i++)
    object_parameter[i] = object_parameter[i] 
                          + sigma*gaussOP.SampleNormalZeroOne();
}

// ****************************************************************
// ****************************************************************

bool operator < (const Individual& a, const Individual& b)
{ return (a.fitness < b.fitness); }

// ****************************************************************

bool operator > (const Individual& a, const Individual& b)
{ return (a.fitness > b.fitness); }

// ****************************************************************
// ****************************************************************

#endif
